@ECHO OFF
SETLOCAL ENABLEDELAYEDEXPANSION 
cls

::==CHANGE THESE VALUES FOR YOUR SETUP==================================================
::======================================================================================
set SName=localhost\SAMBAPOS3
set DbName=SambaPOS3
set UserName="sa"
set Password="xxxxxx"
set workpath="D:\SambaPOS3\"
set ConnectionString="-S %SName% -d %DbName% -U %UserName% -P %Password%"
::======================================================================================
::======================================================================================

set ERRFILE="!workpath:"=!_AddInventory_error.txt"
set TEMPFILE="!workpath:"=!_AddInventory_temp.txt"
set connStr=!ConnectionString:"=!

set TicketID=%1
set DepartmentName=%~2
set WarehouseOverrideName=%~3
set InventoryTransactionTypeName='create transaction'

if exist %ERRFILE% del %ERRFILE%

::----------make new inventory transaction document, get its ID
::-------------------------------------------------------------
set SQLFILE="!workpath:"=!NewInventoryItemTransactionDocument.sql"
sqlcmd %connStr% -W -I -h-1 -i %SQLFILE% > %TEMPFILE%
set /p TransactionDocumentID=< %TEMPFILE%

::----------find the Warehouse Name to be used-----------------
::-------------------------------------------------------------
if "!WarehouseOverrideName!"=="" (
  set SQL="set nocount on; SELECT Warehouses.Name FROM Departments INNER JOIN Warehouses ON Warehouses.Id = Departments.WarehouseId WHERE Departments.Name = '%DepartmentName%'"
  sqlcmd %connStr% -W -I -h-1 -Q !SQL! > %TEMPFILE%
  set /p WarehouseName=< %TEMPFILE%
) else (
  set WarehouseName=%WarehouseOverrideName%
)

::----------select all product names and quantities for the ticket----
::--------------------------------------------------------------------
set SQL="set nocount on; SELECT MenuItemName, O.Quantity FROM Orders O WHERE O.TicketId = %TicketID%"
sqlcmd %connStr% -W -s "|" -I -h-1 -Q %SQL% > %TEMPFILE%

for /f "usebackq tokens=1,2 delims=|" %%a in (%TEMPFILE%) do (
  set InventoryName=%%a
  set Quantity=%%b

  ::----------find the InventoryItem ID--------------------------
  ::-------------------------------------------------------------
  set SQL="set nocount on; SELECT ID FROM InventoryItems WHERE Name = '!InventoryName!'"
  sqlcmd %connStr% -W -I -h-1 -Q !SQL! > %TEMPFILE%
  set /p InventoryItemID=< %TEMPFILE%

  ::----------make new inventory transaction---------------------
  ::-------------------------------------------------------------
  set SQLFILE="!workpath:"=!NewInventoryTransaction.sql"
  sqlcmd %connStr% -W -I -h-1 -i !SQLFILE! /v InventoryTransactionDocumentID=%TransactionDocumentID% InventoryTransactionTypeName="%InventoryTransactionTypeName%" DepartmentName="'%DepartmentName%'" WarehouseOverrideName="'%WarehouseName%'" InventoryItemID=!InventoryItemID! Quantity=!Quantity! Price=0 > %ERRFILE%
)
if exist %TEMPFILE% del %TEMPFILE%
